package de.intevation.flys.artifacts.model;

import java.util.List;

import de.intevation.flys.backend.SessionHolder;
import de.intevation.flys.model.River;
import de.intevation.flys.model.Wst;

import org.hibernate.Query;
import org.hibernate.Session;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class WstFactory {

    /** We don't need to instantiate concrete objects of this class. */
    private WstFactory() {
    }


    /**
     * Returns the Wst object for a given river.
     *
     * @param river The river.
     *
     * @return the Wst of <i>river</i>.
     */
    public static Wst getWst(River river) {
        Session session = SessionHolder.HOLDER.get();

        Query query = session.createQuery(
            "from Wst where river=:river");
        query.setParameter("river", river);

        List<Wst> wst = query.list();

        return (wst != null && wst.size() > 0) ? wst.get(0) : null;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
