package de.intevation.flys.exports;

import org.apache.log4j.Logger;

import au.com.bytecode.opencsv.CSVWriter;

import de.intevation.artifacts.Artifact;

import de.intevation.flys.artifacts.WINFOArtifact;
import de.intevation.flys.artifacts.model.WQCKms;
import de.intevation.flys.artifacts.model.WQKms;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class DischargeLongitudinalSectionExporter extends WaterlevelExporter {

    /** The logger used in this exporter.*/
    private static Logger logger =
        Logger.getLogger(DischargeLongitudinalSectionExporter.class);


    @Override
    protected void addData(Artifact artifact) {
        WINFOArtifact winfo = (WINFOArtifact) artifact;
        WQKms[]       wqkms = winfo.getDischargeLongitudinalSectionData();

        logger.debug("Got " + wqkms != null ? wqkms.length : 0 + " WQKms obj.");

        data.add(wqkms);
    }


    @Override
    protected void wQKms2CSV(CSVWriter writer, WQKms wqkms) {
        logger.debug("WaterlevelExporter.wQKms2CSV");

        int      size   = wqkms.size();
        double[] result = new double[4];

        for (int i = 0; i < size; i ++) {
            result = wqkms.get(i, result);

            String wc = "";
            if (wqkms instanceof WQCKms) {
                wc = Double.toString(result[3]);
            }

            writer.writeNext(new String[] {
                Double.toString(result[2]),
                Double.toString(result[0]),
                wc,
                Double.toString(result[1])
            });
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
